// PWM header written by John Palmisano to make life much easier =)
// WORKS ON ALL NEW CEREBELLUMS
// to use, motors(left motor speed, right motor speed)
// accepts values from -100 => 100
// Runs at 19.5 kHz by default

inline void pwm_setup()
	{
	setup_timer_2(T2_DIV_BY_1,255,1);
		
	setup_ccp1(CCP_PWM);
	setup_ccp2(CCP_PWM);
	output_low(PIN_C2);//pwm1
	output_low(PIN_C1);//pwm2
	
	set_pwm1_duty(0);
	set_pwm2_duty(0);
	}

void motorresist()
	{
	output_low(PIN_C0);
	output_low(PIN_A4);
	output_low(PIN_C5);
	output_low(PIN_B1);
	}

void motors(signed long int l, signed long int r)
	{
	//makes sure values are in correct range
	if (l > 100)
		l=100;
	if (l < -100)
		l=-100;
	if (r > 100)
		r=100;
	if (r < -100)
		r=-100;
	
	//convert from a ~1023 (off full) and 0 (on full)
	l=l*10;
	r=r*10;
	//-32768=>32767 signed long int

	//setting motors
	if (l >= 0)//forward
		{
		l=1000-l;
		if (l>999)
			l=1023;
		output_high(PIN_C0);
		output_low(PIN_A4);
		}

	else//reverse
		{
		output_low(PIN_C0);
		output_high(PIN_A4);
		}

	set_pwm1_duty(~l);

	if (r >= 0)//forward
		{
		r=1000-r;
		if (r>999)
			r=1023;
		output_high(PIN_C5);
		output_low(PIN_B1);
		}
	
	else//reverse
		{
		output_low(PIN_C5);
		output_high(PIN_B1);
		}
	
	set_pwm2_duty(~r);
	}
